﻿<AML>
 <Item type="Method" id="442B929F0AA04FE5B7A7EAEAD078486B" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			GetStockByPartNumber
            Created By/Company:		Sandar 
            Creation Date:			2019-08-13
            Description:
                At the time of excel import, plz. check part number is already existed in part items. 
                If part item is already existed, create stock for that part number.

            Hooks:
                Type:		***
                Event:		***
                Called by:	sop_so_excel_import_format1
                            sop_so_excel_import_format2
                            sop_so_excel_import_format3
                            sop_so_excel_import_format4

            Inputs:
                <describe the inputs expected by the server method>

            Revisions:
                Rev Date		Modified By			Description
                YYYY-MM-DD		***					Initial creation
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if (System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "GetStockByPartNumber";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                var itemNumber = this.getProperty("itemNumber", "");

                string stkID = "";

                Item itemStock = myInnovator.newItem("stk_stock_setup", "get");
                itemStock.setProperty("stk_code", itemNumber.Trim());
                itemStock.setPropertyCondition("stk_code", "eq");
                itemStock = itemStock.apply();
                if (itemStock.getItemCount() > 0)
                {
                    stkID = itemStock.getID();
                }

                if (itemStock.isError())
                {
                    Item getPartItem = myInnovator.getItemByKeyedName("Part", itemNumber);
                    Item Newstock_Item_result = myInnovator.newItem("", "");
                    if (getPartItem != null)
                    {
                        /** add stock **/
                        string UOM_ID = "";
                        string itemTypeName = getPartItem.getType();
                        string itemKeyedName = getPartItem.getProperty("keyed_name", "");
                        string PartId = getPartItem.getProperty("id", "");
                        string Item_Number = getPartItem.getProperty("item_number", "");
                        string Description = getPartItem.getProperty("description", "");
                        string name = getPartItem.getProperty("name", "");
                        string thumbnail_pic = getPartItem.getProperty("thumbnail", "");
                        string Unit = getPartItem.getProperty("unit", "");
                        string Major_REV = getPartItem.getProperty("major_rev", "");
                        string cost = getPartItem.getProperty("cost", "");
                        if (cost == "")
                        {
                            cost = "0";
                        }
                        Item Stock_UOM = myInnovator.newItem("stk_UOM", "get");
                        Stock_UOM.setProperty("keyed_name", Unit);
                        Stock_UOM = Stock_UOM.apply();
                        if (Stock_UOM.getItemCount() > 0)
                        {
                            UOM_ID = Stock_UOM.getID();
                        }
                        Item newStock = myInnovator.newItem("stk_stock_setup", "add");
                        newStock.setProperty("stk_code", itemKeyedName);
                        newStock.setProperty("part_no", PartId);
                        newStock.setProperty("stk_description", Description);
                        newStock.setProperty("stk_name", name);
                        newStock.setProperty("thumbnail", thumbnail_pic);
                        newStock.setProperty("stk_uom", UOM_ID);
                        newStock.setProperty("stk_rev", Major_REV);
                        newStock.setProperty("stk_price", cost);
                        newStock.setProperty("stk_cost", cost);

                        /** add stock location **/
                        var newLocation = myInnovator.newItem("stk_stock_location", "add");
                        // newLocation.setProperty("source_id", stock_id);
                        newLocation.setProperty("stk_holding_qty", "0.0");
                        newLocation.setProperty("stk_indicator", "#FFFFFF");
                        newLocation.setProperty("stk_min_qty", "0.0");
                        newLocation.setProperty("stk_reserved_qty", "0.0");

                        var defaultLocation = myInnovator.newItem("stk_location", "get");
                        defaultLocation.setProperty("stk_location_default", "1");
                        var stk_location = defaultLocation.apply();

                        if (stk_location.getItemCount() > 0)
                        {
                            // defaultLocation = stk_location.getItemByIndex(0);
                            newLocation.setRelatedItem(stk_location);

                            /** add relationship of stock location **/
                            newStock.addRelationship(newLocation);
                            if (newStock.isError())
                            {
                                return myInnovator.newError("Error : add_allpartBOM_to_Stock method.");
                            }
                        }

                        Newstock_Item_result = newStock.apply();
                        if (Newstock_Item_result.isError())
                        {
                            return myInnovator.newError(Newstock_Item_result.getErrorString());
                        }
                        stkID = Newstock_Item_result.getID();
                    }
                }
                return result = myInnovator.newResult(stkID);
            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }]]></method_code>
  <method_type>C#</method_type>
  <name>GetStockByPartNumber</name>
 </Item>
</AML>